#include "AsioWrapper.h"

extern "C"
{
#ifdef VUO_COMPILER
VuoModuleMetadata({
					"title" : "AsioWrapper",
					"dependencies" : [],
				});
#endif
}

#include <iostream>
#include <istream>
#include <ostream>
#include <sstream>
#include <string>
#include "asio.hpp"

using asio::ip::udp;

VuoData receiveUDPMessage(VuoInteger port)
{
    unsigned short shortPort = (unsigned short)port;
    unsigned char* outData;

    try
    {
        asio::io_context io_context;

        for (;;)
        {
            asio::ip::udp::socket socket(
                        io_context,
                        asio::ip::udp::endpoint{asio::ip::udp::v4(), shortPort}
                        );

            asio::ip::udp::endpoint client;
            char recv_str[1024] = {};

            socket.receive_from(
                        asio::buffer(recv_str),
                        client
                        );

            outData = (unsigned char*)recv_str;
        }
    }

    catch (std::exception& e)
    {
        std::cerr << "Exception: " << e.what() << "\n";
    }

    VuoData received = VuoData_make(1024, outData);

    return received;

}
